# Grappling hook cooldown
scoreboard objectives add can_hook_in dummy
scoreboard players add @a can_hook_in 0
scoreboard players add @a[scores={can_hook_in=0..}] can_hook_in -1
execute as @a[scores={can_hook_in=0..}] at @s run kill @e[name="Lead", r=6, type=item]
execute as @e[type=ale:hook_ride] at @s run scoreboard players add @p[r=2] can_hook_in 1

# Tp hook rider to player
execute as @a[scores={can_hook_in=0..}] at @s run tp @e[type=ale:hook_rider,tag=!tped,c=1] @s
tag @e[type=ale:hook_rider,tag=!tped] add tped

# Let the player ride the hook_ride which rides a hook_rider
execute as @a[scores={can_hook_in=0..},tag=!is_riding_ride] at @s run ride @s start_riding @e[type=ale:hook_ride, c=1] teleport_ride if_group_fits
execute as @e[type=ale:hook_ride] at @s run ride @s start_riding @e[type=ale:hook_rider,c=1] teleport_ride if_group_fits
execute as @e[type=ale:hook_ride] at @s run tag @p[scores={can_hook_in=0..},r=2] add is_riding_ride

# Hook ride sound
scoreboard objectives add sound_cd dummy
scoreboard players add @e[type=ale:hook_ride] sound_cd 0
execute as @e[type=ale:hook_ride, scores={sound_cd=0}] at @s run playsound entity.hook_air @a ~~~
scoreboard players set @e[type=ale:hook_ride, scores={sound_cd=0}] sound_cd 10

# Check if the player has dismounted and then reset his hook timer
tag @a remove found_ride
execute as @a[tag=is_riding_ride] at @s if entity @e[type=ale:hook_ride, r=5] run tag @s add found_ride
execute as @a[tag=is_riding_ride, tag=!found_ride] at @s run execute as @e[type=ale:hook_ride,r=10,c=1] at @s run function gadgets/grappling_hook/kill
scoreboard players set @a[tag=is_riding_ride, tag=!found_ride] can_hook_in 0

# Hooking animation
event entity @a ale:remove_hooked
execute as @e[type=ale:hook_ride] at @s run event entity @a[r=3] ale:is_hooked
execute as @e[type=ale:hook_ride] at @s run scoreboard players set @a[r=2] no_fall_dmg 120

# Tp hook source
execute as @e[type=ale:hook_source] at @s run tp @s @p

# Tp hook rider faster than it normally does

scoreboard objectives add lifetime dummy
scoreboard players add @e[family=grappling_hook] lifetime 1
execute as @e[type=ale:hook_rider, scores={lifetime=3..}] at @s if entity @p[tag=is_riding_ride, tag=found_ride, r=6] run tp @s ^^^1 facing @e[c=1,type=ale:hook_dest]

# Kill the grappling hook entities
execute as @e[type=ale:hook_rider] at @s unless entity @p[r=7] run execute as @e[type=ale:hook_dest,c=1,r=0.7] at @s run function gadgets/grappling_hook/kill
execute as @a[tag=is_riding_ride, tag=found_ride] at @s run scoreboard players add @e[type=ale:hook_dest,c=1,r=1] hook_time 40

# Reset the hook timer if the hook did not hit anything
execute as @e[type=ale:hook_ride] at @s run scoreboard players set @a[r=2] no_fall_dmg 120
execute as @e[type=ale:zipline_arrow,scores={hook_time=80..}] at @s run scoreboard players set @p can_hook_in 0
event entity @e[type=ale:zipline_arrow,scores={hook_time=80..}] ale:despawn

# --- Let the player dismount earlier than hitting the wall
scoreboard objectives add hit_wall dummy
scoreboard players set @a hit_wall 3
execute as @a at @s anchored eyes if block ^^^0.2 air [] run scoreboard players remove @s hit_wall 1
execute as @a at @s anchored eyes if block ^^^0.5 air [] run scoreboard players remove @s hit_wall 1
execute as @a at @s anchored eyes if block ^^^0.6 air [] run scoreboard players remove @s hit_wall 1

execute as @a[scores={hit_wall=1..}] at @s run scoreboard players add @e[type=ale:hook_dest, c=1] hook_time 5
execute as @a[scores={hit_wall=1..}] at @s run scoreboard players add @e[type=ale:hook_source, c=1] hook_time 5
execute as @a[scores={hit_wall=1..}] at @s run scoreboard players add @e[type=ale:hook_ride, c=1] hook_time 5
execute as @a[scores={hit_wall=1..}] at @s run scoreboard players add @e[type=ale:hook_rider, c=1] hook_time 5
execute as @a[scores={hit_wall=2..}] at @s run scoreboard players add @e[type=ale:hook_dest, c=1] hook_time 5
execute as @a[scores={hit_wall=2..}] at @s run scoreboard players add @e[type=ale:hook_source, c=1] hook_time 5
execute as @a[scores={hit_wall=2..}] at @s run scoreboard players add @e[type=ale:hook_ride, c=1] hook_time 5
execute as @a[scores={hit_wall=2..}] at @s run scoreboard players add @e[type=ale:hook_rider, c=1] hook_time 5

execute as @a[tag=is_riding_ride, scores={hit_wall=..0}] at @s run scoreboard players add @e[type=ale:hook_dest, c=1, scores={hook_time=50..}] hook_time -15
execute as @a[tag=is_riding_ride, scores={hit_wall=..0}] at @s run scoreboard players add @e[type=ale:hook_source, c=1, scores={hook_time=50..}] hook_time -15
execute as @a[tag=is_riding_ride, scores={hit_wall=..0}] at @s run scoreboard players add @e[type=ale:hook_ride, c=1, scores={hook_time=50..}] hook_time -15
execute as @a[tag=is_riding_ride, scores={hit_wall=..0}] at @s run scoreboard players add @e[type=ale:hook_rider, c=1, scores={hook_time=50..}] hook_time -15

# ---

# Error killing (if something goes wrong)
scoreboard objectives add hook_time dummy
execute as @a[scores={can_hook_in=0..}] at @s run scoreboard players add @e[type=ale:hook_source,r=2] hook_time 1
scoreboard players add @e[family=grappling_hook] hook_time 1

execute as @e[type=ale:hook_dest] at @s unless entity @p[r=70, tag=is_riding_ride, tag=found_ride] run scoreboard players add @s hook_time 40
execute as @e[type=ale:hook_ride] at @s unless entity @e[r=70, type=ale:hook_dest] run scoreboard players add @s hook_time 40
execute as @e[type=ale:hook_rider] at @s unless entity @e[r=70, type=ale:hook_dest] run scoreboard players add @s hook_time 40

tag @e[family=grappling_hook] remove close_to_player
execute as @a at @s run tag @e[c=1, type=ale:hook_dest, tag=!close_to_player] add close_to_player
execute as @a at @s run tag @e[c=1, type=ale:hook_source, tag=!close_to_player] add close_to_player
execute as @a at @s run tag @e[c=1, type=ale:hook_ride, tag=!close_to_player] add close_to_player
execute as @a at @s run tag @e[c=1, type=ale:hook_rider, tag=!close_to_player] add close_to_player
execute as @a at @s run tag @e[c=1, type=ale:zipline_arrow, tag=!close_to_player] add close_to_player

execute as @e[scores={hook_time=150..}] at @s run function gadgets/grappling_hook/kill
kill @e[scores={hook_time=200..}]
event entity @e[family=grappling_hook, tag=!close_to_player] ale:despawn

# Check if we dont hit anything
execute as @e[type=ale:zipline_arrow, scores={lifetime=59..}] at @s run execute as @p[scores={can_hook_in=0..}] at @s run event entity @e[type=ale:hook_source,c=1, r=5] ale:despawn
event entity @e[type=ale:zipline_arrow, scores={lifetime=59..}] ale:despawn